#ifndef _STD_LOG_H
#define _STD_LOG_H

#ifndef   LOG_TAG
#define   LOG_TAG   "loger"
#endif

#include "ANSI/common.h"

#if TARGET_OS_ANDROID
#include <android/log.h>

#define    LOGI(format, arg...)   __android_log_print(ANDROID_LOG_INFO, LOG_TAG, format, ##arg);
#define    LOGW(format, arg...)   __android_log_print(ANDROID_LOG_WARN, LOG_TAG, format, ##arg);
#define    LOGE(format, arg...)   __android_log_print(ANDROID_LOG_ERROR, LOG_TAG, format, ##arg);
#define    LOGD(format, arg...)   __android_log_print(ANDROID_LOG_DEBUG, LOG_TAG, format, ##arg);

#elif TARGET_OS_MAC || TARGET_OS_IPHONE

#define    LOGI(format, arg...)
#define    LOGW(format, arg...)
#define    LOGE(format, arg...)
#define    LOGD(format, arg...)

#elif TARGET_OS_WIN32

#define    LOGI(format, ...)
#define    LOGW(format, ...)
#define    LOGE(format, ...)
#define    LOGD(format, ...)

#else

#define    LOGI(format, ...)
#define    LOGW(format, ...)
#define    LOGE(format, ...)
#define    LOGD(format, ...)

#endif

#endif