package com.emu.cc800;

import android.app.Activity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.SurfaceView;

public class CC800Activity extends Activity {
	private Emulator mEmulator = Emulator.getInstance();
	private SurfaceView mSurfaceView;
	private KeyBoard mKeyBoard;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		initViews();
	}
	
	@Override
	protected void onResume() {
		super.onResume();
		mEmulator.start();
	}
	
	@Override
	protected void onStop() {
		super.onStop();
		mEmulator.stop();
	}
	
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			finish();
			return true;
		}
		return mKeyBoard.onKeyEvent(keyCode, KeyEvent.ACTION_DOWN);
	}
	
	@Override
	public boolean onKeyUp(int keyCode, KeyEvent event) {
		return mKeyBoard.onKeyEvent(keyCode, KeyEvent.ACTION_UP);
	}

	private void initViews() {
		mSurfaceView = (SurfaceView) findViewById(R.id.emu_surface_screen);
		mEmulator.setSurface(mSurfaceView.getHolder());
		mKeyBoard = (KeyBoard) findViewById(R.id.emu_keybd_board);
		mKeyBoard.setOnKeyListener(mEmulator);
	}
}