//
//  CCLCDVIEW.m
//  Sim800IOS


#import "CCLCDVIEW.h"

@interface CCLCDVIEW ()

-(void)drawLCDBuffer;

@end


@implementation CCLCDVIEW

@synthesize lcdBuffer = LCDBuffer;

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
    }
    return self;
}

-(void)clearScreen
{
    if (LCDBuffer != NULL) {
        memset(LCDBuffer, 0, 160*80/8);
        [self setNeedsDisplay];
    }
}

-(void)setLcdBuffer:(char *)lcdBuffer
{
    LCDBuffer = lcdBuffer;
}

-(void)drawLCDBuffer
{
    if (LCDBuffer == NULL) {
        NSLog(@"LCDBuffer is empty");
        return;
    }
    CGContextRef c = UIGraphicsGetCurrentContext();
    CGContextSetRGBStrokeColor(c, 0, 0, 0, 1);
    CGContextSetLineWidth(c, 1);
    for (int i=0; i<80; i++) {//height
        for (int j=0; j<20; j++) {//width
            int offset = 20*i+j;
            unsigned char p = LCDBuffer[offset];
            for (int z=8; z>0; z--) {
              int color = p & (1 << (8-z));
                
              if (color == 0) CGContextSetRGBFillColor(c, 0, 1, 0, 1);
              else CGContextSetRGBFillColor(c, 0, 0, 0, 1);
                
              if (z == 1 && color){
                    if (j > 0) CGContextFillRect(c, CGRectMake( (j*8+z-1)*2, i*2 , 2, 2));
              }
              else CGContextFillRect(c, CGRectMake( (j*8+z-1)*2, i*2 , 2, 2));

            }
        }
    }
}

// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
    // Drawing code
   [self drawLCDBuffer];
}


@end
