//
//  CCViewController.m
//  Sim800IOS

#import "CCViewController.h"
#include "COMMON.h"
#import "NekoDriver.h"
#import "CCLCDVIEW.h"


char LCDBUFFER[160*80/8];

id screenView = nil;

void lcdBufferChanged(const char* buffer) 
{
    memcpy(LCDBUFFER, buffer, 160*80/8);
    [screenView performSelectorOnMainThread:@selector(setNeedsDisplay) withObject:screenView waitUntilDone:NO];    
}


@interface CCViewController () <CCKeyboardDelegate> {
    TNekoDriver theNekoDriver;
}

@end

@implementation CCViewController
@synthesize lcdView;
@synthesize keyboard;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    self.lcdView.lcdBuffer = LCDBUFFER;
    screenView = lcdView;
    keyboard.keyboardDelegate = self;
    theNekoDriver.SetOnLCDBufferChanged(lcdBufferChanged);
    theNekoDriver.RunDemoBin([[[NSBundle mainBundle] resourcePath] UTF8String]);
}

-(void)onPower
{
    NSLog(@"%d", theNekoDriver.IsStarted());
    if (theNekoDriver.IsStarted()) {
        theNekoDriver.StopEmulation();
        [lcdView clearScreen];
    }
    else
        theNekoDriver.RunDemoBin([[[NSBundle mainBundle] resourcePath] UTF8String]);
        
}

- (void)viewDidUnload
{
    [self setLcdView:nil];
    [self setKeyboard:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    theNekoDriver.StopEmulation();
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return YES;//(interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (void)dealloc {
    [lcdView release];
    [keyboard release];
    [super dealloc];
}
@end
