#ifndef _CC800_KEYBOARD_H
#define _CC800_KEYBOARD_H


#include "NekoDriver.h"

//10X6
typedef struct {
    char keyCode;
    char *keyValue;
    int index;
    char mapping;
}KeyItem;

#define INVALID_KEY -1

static KeyItem keyMappingTable[60] = 
{
    {0, "Dict", 8},
    {1, "Card", 9},
    {2, "Calc", 10},
    {3, "Rem", 11},
    {4, "Data", 12},
    {5, "Time", 13},
    {6, "Net", 14},
    {-1, NULL}, 
    {-1, NULL},
    {-1, NULL},
    
    {-1, NULL},
    {-1, NULL},
    {12, "F1", 58},
    {13, "F2", 59},
    {14, "F3", 60},
    {15, "F4", 61},
    {-1, NULL}, 
    {-1, NULL},
    {18, "On", 2}, 
    {-1, NULL},
    
    {20, "Q", 40},
    {21, "W", 41},
    {22, "E", 42},
    {23, "R", 43},
    {24, "T", 44},
    {25, "Y", 45},
    {26, "U", 46},
    {27, "I", 47},
    {28, "O", 48},
    {29, "P", 52},
    
    {30, "A", 32},
    {31, "S", 33},
    {32, "D", 34},
    {33, "F", 35},
    {34, "G", 36},
    {35, "H", 37},
    {36, "J", 38},
    {37, "K", 39}, 
    {38, "L", 49},
    {39, "Enter", 53},
    
    {40, "Z", 24},
    {41, "X", 25},
    {42, "C", 26},
    {43, "V", 27},
    {44, "B", 28},
    {45, "N", 29},
    {46, "M", 30},
    {47, "PgUp", 31},
    {48, "Up", 50},
    {49, "PgDn", 51},
    
    {50, "Help", 16},
    {51, "Shft", 17},
    {52, "Caps", 18},
    {53, "Esc", 19},
    {54, "0", 20},
    {55, ".", 21},
    {56, "=", 22},
    {57, "Left", 23}, 
    {58, "Down", 51},
    {59, "Right", 55}    
};


#endif
