#ifndef _STD_THREAD_H
#define _STD_THREAD_H

#include <pthread.h>

class Thread
{
public:
    Thread();
    ~Thread();
    
private:
    static void* startProc(void*);
    
protected:
    virtual void run() = 0;
    
public:
    void start();
    void stop();
    void join();
    void wait();
    void wait(int msecs);
	void notify();
	bool isInterrupted();
	void interrupt();
	bool isStarted();

protected:
    pthread_t mThread;
    pthread_cond_t mCondition;
	pthread_mutex_t mMutex;
	bool mStarted;
	bool mInterrupted;
};

#endif
